using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();

			dt = GetTable();

			this.gridControl1.Model.Options.MergeCellsMode = GridMergeCellsMode.BeforeDisplayCalculation | GridMergeCellsMode.MergeRowsInColumn;
			this.gridControl1.QueryCanMergeCells += new GridQueryCanMergeCellsEventHandler(gridControl1_QueryCanMergeCells);

			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
			this.gridControl1.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
			this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);
			this.gridControl1.ResetVolatileData();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(16, 16);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(352, 272);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.Resize += new System.EventHandler(this.gridControl1_Resize);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 342);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;

		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				e.Style.CellValue = dt.Rows[e.RowIndex-1][e.ColIndex-1];
				e.Style.MergeCell = GridMergeCellDirection.RowsInColumn;
			}
			else if(e.ColIndex > 0 && e.RowIndex == 0)
			{
				e.Style.Text = this.dt.Columns[e.ColIndex-1].ColumnName;
			}
			e.Handled = true;

		}
		int nCols;
		int nRows;
		private DataTable GetTable()
		{
			nCols = 50;
			nRows = 500;
			DataTable dt = new DataTable("table");
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = 5;
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Columns.Count;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Rows.Count;
			e.Handled = true;
		}
		
		private void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
				dt.Rows[e.RowIndex-1][e.ColIndex-1] = e.Style.CellValue.ToString();
			e.Handled = true;
		}

		private void gridControl1_Resize(object sender, System.EventArgs e)
		{
			this.gridControl1.Refresh();
		}

		private void gridControl1_QueryCanMergeCells(object sender, GridQueryCanMergeCellsEventArgs e)
		{
			int rowIndex1 = e.Style1.CellIdentity.RowIndex;
			int rowIndex2 = e.Style2.CellIdentity.RowIndex;

			if (!this.gridControl1.ViewLayout.IsRangeVisible(GridRangeInfo.Rows(rowIndex1, rowIndex2)))
			{
				e.Result = false;
				e.Handled = true;
			}
		}
	}
}
